//#ifndef __INPLANETORTUOSITY_H__
//#define __INPLANETORTUOSITY_H__

#pragma once

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <malloc.h>
#include <fstream>
#include <iostream>

//#include "Log_IO.h"
//#include "bmp_io.h"
//#include "extract.h"

#include "TortuosityDialog.h"
#include "DS_1b_cube.h"

#include "MainFrm.h"


//#include "photoinfo.h"
//#include "extract.h"
//#include "threshold.h"
//#include "binarize.h"
//#include "MainFrm.h"
//#include "cDS_lib.h"

//#define MAX_TTY 500
//#define STORAGE_W 24
//#define BACKUP_SIZE 300

//#include <malloc.h>
//#include "Tortuosity.h"

//#ifdef __cplusplus
//extern "C"
//{
//#endif


	/*unsigned short int tortDistribution(char *input, char *output, char* bmp_name, int sS, int lS,
					  int sX, int sY, int wX, int wY, int thres, int runs, int invert, int res, int type, int manual);*/
class Tortuosity
{
public:
	Tortuosity(DS_1b_cube *ds_new_cube, void *new_TortDlg);
	~Tortuosity();

	unsigned short int run_tortuosity(char* out_name, int nPores, unsigned short int depth, int rec_tracer_num);
	bool send_tracer();


private:
	
	void add_vector_node(unsigned short int z, unsigned short int y, unsigned short int x);
	void clear_vector_list();


	typedef struct _vector_node
	{
		unsigned short int x, y, z;
		_vector_node * next;
	} vector_node;

	vector_node *head, *tail;

	TortuosityDialog* TortDlg;
	DS_1b_cube *path_cube, *ds_cube, *tracers_cube;
	unsigned short int s, r, c;
	unsigned short int wX, wY, wZ;
	double length;
};

//#ifdef __cplusplus
//}
//#endif
//
//#endif