
#include "afxwin.h"
#include "PoroMediaDialogShare.h"
#include "TortuosityInput.h"

#if !defined(AFX_TORTUOSITYDIALOG_H__7E8CB014_B67D_42BE_A62D_F4A75C7CD1B8__INCLUDED_)
#define AFX_TORTUOSITYDIALOG_H__7E8CB014_B67D_42BE_A62D_F4A75C7CD1B8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TortuosityDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// TortuosityDialog dialog


class TortuosityDialog : public CDialog, public PoroMediaDialogShare
{
// Construction
public:
	TortuosityDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(TortuosityDialog)
	enum { IDD = IDD_TORT_DIALOG };
		
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(TortuosityDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(TortuosityDialog)
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
		
	//run settings
	CButton check_run_XY_cntrl;
	CButton check_run_YZ_cntrl;
	CButton check_run_XZ_cntrl;
	CEdit field_run_num_XY_cntrl;
	CEdit field_run_num_YZ_cntrl;
	CEdit field_run_num_XZ_cntrl;
	int field_run_num_XY_int;
	int field_run_num_YZ_int;
	int field_run_num_XZ_int;
	CButton check_runall_XY;
	CButton check_runall_YZ;
	CButton check_runall_XZ;
	CEdit field_end_depth_XY_cntrl;
	CEdit field_end_depth_YZ_cntrl;
	CEdit field_end_depth_XZ_cntrl;
	int field_end_depth_XY_int;
	int field_end_depth_YZ_int;
	int field_end_depth_XZ_int;
	CEdit field_num_save_tracers_XY_cntrl;
	CEdit field_num_save_tracers_YZ_cntrl;
	CEdit field_num_save_tracers_XZ_cntrl;
	int field_num_save_tracers_XY_int;
	int field_num_save_tracers_YZ_int;
	int field_num_save_tracers_XZ_int;

	//advanced options
	CButton check_enable_add_options;
	CEdit field_output_dist_res_cntrl;
	int field_output_dist_res_int;

	//check flags
	bool flag_XY_run_all;
	bool flag_YZ_run_all;
	bool flag_XZ_run_all;

	//general
	afx_msg void OnBnClickedButtonInputDirectory();
	afx_msg void OnBnClickedButtonWorkDirectory();
	afx_msg void OnCbnSelchangeComboThresholdingMethod();
	afx_msg void OnBnClickedStop();
	afx_msg void OnEnChangeEditWidthSlices();
	afx_msg void OnEnChangeEditEndSlice();
	afx_msg void OnEnChangeEditWidthx();
	afx_msg void OnEnChangeEditEndx();
	afx_msg void OnEnChangeEditWidthy();
	afx_msg void OnEnChangeEditEndy();
	afx_msg void OnEnChangeEditStartSlice();
	afx_msg void OnEnChangeEditStartx();
	afx_msg void OnEnChangeEditStarty();
	afx_msg void OnEnChangeEditManualThreshold();
	//specific
	afx_msg void OnBnClickedCheckXyRunall();
	afx_msg void OnBnClickedCheckYzRunall();
	afx_msg void OnBnClickedCheckXzRunall();
	afx_msg void OnBnClickedCheckEnableAddOptions();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TORTUOSITYDIALOG_H__7E8CB014_B67D_42BE_A62D_F4A75C7CD1B8__INCLUDED_)
